<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<?enunciate-assumed-base-uri ./?>
<wadl:application xmlns:wadl="http://wadl.dev.java.net/2009/02" xmlns:xs="http://www.w3.org/2001/XMLSchema">

  <wadl:doc xmlns:enunciate="http://enunciate.webcohesion.com/" enunciate:generatedBy="Enunciate-2.0"/>
  
  <wadl:grammars>
    <wadl:include href="ns1.xsd"/>
    <wadl:include href="ns4.xsd"/>
    <wadl:include href="ns2.xsd"/>
    <wadl:include href="ns3.xsd"/>
    <wadl:include href="ns5.xsd"/>
    <wadl:include href="ns0.xsd"/>
  </wadl:grammars>

  <wadl:resources base="./">

    <wadl:resource path="rest/amalgamationType">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[The list of Amalgamation codes
Represents an amalgamation type for a parameter. This is used in the amalgamation property of
the weather data standard. The id is in binary, so it's bitmapped
This means that if several tests fails for a parameter, each test can be specified.
E.g. If a parameter has been both interpolated (value=2) and replaced (value=2), the
value will be 3 (1 + 2)]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/parameter">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get a list of all the weather parameters defined in the platform]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[A list of all the weather parameters defined in the platform]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/qc">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[The list of QC codes]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdatasource">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get a list of all the available weather data sources]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[A list of all the available weather data sources]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/amalgamation/amalgamate">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Attempts to give you all the requested parameters for the given location
in the specified period. It's a best effort.]]></wadl:doc>
        <wadl:request>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[logging interval for weather data in seconds. Hourly = 3600, daily= 86400]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[ISO Date (e.g. 2021-09-01)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[ISO Date (e.g. 2021-03-01)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/amalgamation/heartbeat">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="text/plain"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/amalgamation/interpolate">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Linear interpolation. Send the weather data in the request body. Specify what to do with query parameters]]></wadl:doc>
        <wadl:request>
          <wadl:doc><![CDATA[Json weather data in the request body. Can very well include parameters that aren't to be interpolated]]></wadl:doc>
          <wadl:representation mediaType="application/json">
          </wadl:representation>
          <wadl:param name="maxMissingValues" style="query">
            <wadl:doc><![CDATA[Don't interpolate if the number of contiguously missing values exceeds this number (default = 1)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="paramsToInterpolate" style="query">
            <wadl:doc><![CDATA[the parameters to interpolate]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[the weather data set with performed interpolation of the specified parameters]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/country/{countryCodes}">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:request>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:param name="countryCodes" style="template">
        <wadl:doc><![CDATA[]]></wadl:doc>
      </wadl:param>
    </wadl:resource>

    <wadl:resource path="rest/schema/weatherdata">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get the schema that describes the IPM Decision platform's format for
exchange of weather data]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[The weather data <a href="https://json-schema.org/" target="new">Json schema</a>]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/davisfruitweb">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the the network of Fruitweb attached stations
[https://www.fruitweb.info/en/]

This is a network of privately owned weather stations, which all require
authentication to access.]]></wadl:doc>
        <wadl:request>
          <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the the network of Fruitweb attached stations
[https://www.fruitweb.info/en/]

This is a network of privately owned weather stations, which all require
authentication to access.]]></wadl:doc>
          <wadl:representation mediaType="application/x-www-form-urlencoded">
            <wadl:param name="credentials" style="query">
              <wadl:doc><![CDATA[json object with "userName" and "password" properties set]]></wadl:doc>
            </wadl:param>
            <wadl:param name="ignoreErrors" style="query">
              <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
            </wadl:param>
            <wadl:param name="interval" style="query">
              <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="parameters" style="query">
              <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
            </wadl:param>
            <wadl:param name="timeEnd" style="query">
              <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="timeStart" style="query">
              <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="timeZone" style="query">
              <wadl:doc><![CDATA[e.g. "Europe/Oslo". Optional. Default is UTC]]></wadl:doc>
            </wadl:param>
            <wadl:param name="weatherStationId" style="query">
              <wadl:doc><![CDATA[The weather station id]]></wadl:doc>
            </wadl:param>
          </wadl:representation>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/dmipoint">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get weather observations and forecasts in the IPM Decision's weather data format from the Danish Meteorological Institute]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get weather observations and forecasts in the IPM Decision's weather data format from the Danish Meteorological Institute]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/fmi">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the Finnish Meteorological Institute https://en.ilmatieteenlaitos.fi/
Access is made through the Institute's open data API: https://en.ilmatieteenlaitos.fi/open-data]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="weatherStationId" style="query">
            <wadl:doc><![CDATA[The weather station id (FMISID) in the open data API https://en.ilmatieteenlaitos.fi/observation-stations?filterKey=groups&filterQuery=weather]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the Finnish Meteorological Institute https://en.ilmatieteenlaitos.fi/
Access is made through the Institute's open data API: https://en.ilmatieteenlaitos.fi/open-data]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="weatherStationId" style="query">
            <wadl:doc><![CDATA[The weather station id (FMISID) in the open data API https://en.ilmatieteenlaitos.fi/observation-stations?filterKey=groups&filterQuery=weather]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/lantmet">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get weather observations and forecasts in the IPM Decision's weather data format from the LantMet service
of the Swedish University of Agricultural Sciences]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get weather observations and forecasts in the IPM Decision's weather data format from the LantMet service
of the Swedish University of Agricultural Sciences]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/meteireann">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get 9 day weather forecasts from <a href="https://data.gov.ie/" target="new">Met Éireann (Ireland)</a>'s
<a href="https://data.gov.ie/dataset/met-eireann-weather-forecast-api" target="new">Locationforecast API</a>]]></wadl:doc>
        <wadl:request>
          <wadl:param name="altitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[the weather forecast formatted in the IPM Decision platform's weather data format]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get 9 day weather forecasts from <a href="https://data.gov.ie/" target="new">Met Éireann (Ireland)</a>'s
<a href="https://data.gov.ie/dataset/met-eireann-weather-forecast-api" target="new">Locationforecast API</a>]]></wadl:doc>
        <wadl:request>
          <wadl:param name="altitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[the weather forecast formatted in the IPM Decision platform's weather data format]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/meteobot">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the the network of MeteoBot stations
[https://meteobot.com/en/]

This is a network of privately owned weather stations, which all require
authentication to access.]]></wadl:doc>
        <wadl:request>
          <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the the network of MeteoBot stations
[https://meteobot.com/en/]

This is a network of privately owned weather stations, which all require
authentication to access.]]></wadl:doc>
          <wadl:representation mediaType="application/x-www-form-urlencoded">
            <wadl:param name="credentials" style="query">
              <wadl:doc><![CDATA[json object with "userName" and "password" properties set]]></wadl:doc>
            </wadl:param>
            <wadl:param name="ignoreErrors" style="query">
              <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
            </wadl:param>
            <wadl:param name="interval" style="query">
              <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="parameters" style="query">
              <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
            </wadl:param>
            <wadl:param name="timeEnd" style="query">
              <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="timeStart" style="query">
              <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="weatherStationId" style="query">
              <wadl:doc><![CDATA[The weather station id]]></wadl:doc>
            </wadl:param>
          </wadl:representation>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/metos">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the the network of Pessl Instruments Metos stations
[https://metos.at/]

This is a network of privately owned weather stations, which all require
authentication to access.]]></wadl:doc>
        <wadl:request>
          <wadl:doc><![CDATA[Get weather observations in the IPM Decision's weather data format from the the network of Pessl Instruments Metos stations
[https://metos.at/]

This is a network of privately owned weather stations, which all require
authentication to access.]]></wadl:doc>
          <wadl:representation mediaType="application/x-www-form-urlencoded">
            <wadl:param name="credentials" style="query">
              <wadl:doc><![CDATA[json object with "userName" and "password" properties set]]></wadl:doc>
            </wadl:param>
            <wadl:param name="ignoreErrors" style="query">
              <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
            </wadl:param>
            <wadl:param name="interval" style="query">
              <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="parameters" style="query">
              <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
            </wadl:param>
            <wadl:param name="timeEnd" style="query">
              <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="timeStart" style="query">
              <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
            </wadl:param>
            <wadl:param name="weatherStationId" style="query">
              <wadl:doc><![CDATA[The weather station id]]></wadl:doc>
            </wadl:param>
          </wadl:representation>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/openmeteo">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get weather observations and forecasts in the IPM Decision's weather data format from the Open-Meteo.com service]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get weather observations and forecasts in the IPM Decision's weather data format from the Open-Meteo.com service]]></wadl:doc>
        <wadl:request>
          <wadl:param name="ignoreErrors" style="query">
            <wadl:doc><![CDATA[Set to "true" if you want the service to return weather data regardless of there being errors in the service]]></wadl:doc>
          </wadl:param>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[The measuring interval in seconds. Please note that the only allowed interval in this version is 3600 (hourly)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[Comma separated list of the requested weather parameters, given by <a href="/rest/parameter" target="new">their codes</a>]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[End of weather data period (ISO-8601 Timestamp, e.g. 2020-07-03T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[Start of weather data period (ISO-8601 Timestamp, e.g. 2020-06-12T00:00:00+03:00)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/yr">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get 9 day weather forecasts from <a href="https://www.met.no/en" target="new">The Norwegian Meteorological Institute</a>'s
<a href="https://api.met.no/weatherapi/locationforecast/1.9/documentation" target="new">Locationforecast API</a>]]></wadl:doc>
        <wadl:request>
          <wadl:param name="altitude" style="query">
            <wadl:doc><![CDATA[Meters above sea level. This is used for correction of
temperatures (outside of Norway, where the local topological model is used)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[the weather forecast formatted in the IPM Decision platform's weather data format]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get 9 day weather forecasts from <a href="https://www.met.no/en" target="new">The Norwegian Meteorological Institute</a>'s
<a href="https://api.met.no/weatherapi/locationforecast/1.9/documentation" target="new">Locationforecast API</a>]]></wadl:doc>
        <wadl:request>
          <wadl:param name="altitude" style="query">
            <wadl:doc><![CDATA[Meters above sea level. This is used for correction of
temperatures (outside of Norway, where the local topological model is used)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[the weather forecast formatted in the IPM Decision platform's weather data format]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdatasource/location">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Search for weather data sources that serve the specific location. The location
can by any valid Geometry, such as Point or Polygon.
Example GeoJson input
<pre>
 {
        "type": "FeatureCollection",
        "features": [
          {
            "type": "Feature",
            "properties": {},
            "geometry": {
              "type": "Point",
              "coordinates": [
                12.01629638671875,
                59.678835236960765
              ]
            }
          }
        ]
      }
 
 </pre>]]></wadl:doc>
        <wadl:request>
          <wadl:doc><![CDATA[valid GeoJSON https://geojson.org/]]></wadl:doc>
          <wadl:representation mediaType="application/json">
          </wadl:representation>
          <wadl:param name="tolerance" style="query">
            <wadl:doc><![CDATA[Add some tolerance (in meters) to allow for e.g. a point to match
the location of a weather station. The default is 0 meters (no tolerance)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[A list of all the matching weather data sources]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdatasource/{id}">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:request>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:param name="id" style="template">
        <wadl:doc><![CDATA[]]></wadl:doc>
      </wadl:param>
    </wadl:resource>

    <wadl:resource path="rest/weatherparameter/location">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:request>
          <wadl:representation mediaType="application/json">
          </wadl:representation>
          <wadl:representation mediaType="application/xml">
          </wadl:representation>
          <wadl:param name="includeCalculatableParams" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="includeFallbackParams" style="query">
            <wadl:doc><![CDATA[If true, all fallback parameters will be added.The default value is false]]></wadl:doc>
          </wadl:param>
          <wadl:param name="tolerance" style="query">
            <wadl:doc><![CDATA[toleranceInput Add some tolerance (in meters) to allow for e.g. a point to match
the location of a weather station. The default is 0 meters (no tolerance)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/amalgamation/amalgamate/private">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Attempts to give you all the requested parameters for the given location
in the specified period. It's a best effort.]]></wadl:doc>
        <wadl:request>
          <wadl:doc><![CDATA[Json information with information about the private weather data source. Example: {"weatherStationId": "18150444", "weatherSourceId": "com.meteobot", "userName": "theUser","password":"theSuperPassword"}]]></wadl:doc>
          <wadl:representation mediaType="application/json">
          </wadl:representation>
          <wadl:param name="interval" style="query">
            <wadl:doc><![CDATA[logging interval for weather data in seconds. Hourly = 3600, daily= 86400]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeEnd" style="query">
            <wadl:doc><![CDATA[ISO Date (e.g. 2021-09-01)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="timeStart" style="query">
            <wadl:doc><![CDATA[ISO Date (e.g. 2021-03-01)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/amalgamation/amalgamate/proxy">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Given that you can only provide one coordinate, the method handles single locations, not grids]]></wadl:doc>
        <wadl:request>
          <wadl:param name="endpointQueryStr" style="query">
            <wadl:doc><![CDATA[The query parameters. Must be URL encoded (https://en.wikipedia.org/wiki/Percent-encoding)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="endpointURL" style="query">
            <wadl:doc><![CDATA[The URL (excluding query parameters). Must be URL encoded (https://en.wikipedia.org/wiki/Percent-encoding)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[Location Weather data location latitude (Decimal degrees) for amalgamation purposes]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[Location Weather data location longitude (Decimal degrees) for amalgamation purposes]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/schema/weatherdata/validate">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Validates the posted weather data against the <a href="https://json-schema.org/" target="new">Json schema</a>]]></wadl:doc>
        <wadl:request>
          <wadl:doc><![CDATA[The weather data to validate]]></wadl:doc>
          <wadl:representation mediaType="application/json">
          </wadl:representation>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[@return <code>{"isValid":"true"}</code> if the data is valid, <code>{"isValid":"false"}</code> otherwise]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/testdata/weather/qualitycontrol">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatheradapter/fmi/forecasts">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get 36 hour forecasts from FMI (The Finnish Meteorological Institute),
using their OpenData services at https://en.ilmatieteenlaitos.fi/open-data]]></wadl:doc>
        <wadl:request>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[the weather forecast formatted in the IPM Decision platform's weather data format]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Get 36 hour forecasts from FMI (The Finnish Meteorological Institute),
using their OpenData services at https://en.ilmatieteenlaitos.fi/open-data]]></wadl:doc>
        <wadl:request>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[WGS84 Decimal degrees]]></wadl:doc>
          </wadl:param>
          <wadl:param name="parameters" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[the weather forecast formatted in the IPM Decision platform's weather data format]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdata/qualitycontrol/heartbeat">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get API heart beat]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[JSON Object with the message Heartbeat received]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdata/qualitycontrol/nonrt">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Post non-real time weather data for quality control
NON-RT QC implaments
- Step test (parameter values are tested against parameter specific threshold values,
both absolute and relative when applicable)
- Freeze test (parameter values are frozen)]]></wadl:doc>
        <wadl:request>
          <wadl:representation mediaType="application/json">
          </wadl:representation>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdata/qualitycontrol/rt">
      <wadl:method name="POST">
        <wadl:doc><![CDATA[Post real time weather data for quality control
RT QC implements
- Simple prequalification for values (value is numeric)
- Interval test for temperature, soil temperature and wind (parameter values
are tested against lower and upper physical limits)
- Logical test for temperature, soil temperature, humidity and wind (TBD)]]></wadl:doc>
        <wadl:request>
          <wadl:representation mediaType="application/json">
          </wadl:representation>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[Quality controlled weather data. The end-point appends qc arrays
into location weather data objects.]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdata/qualitycontrol/threshold">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Get weather parameter specific threshold data object with applicable min, max, threshold value and threshold value type]]></wadl:doc>
        <wadl:request>
          <wadl:param name="parameterid" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[JSON Object with parameter specific threshold data]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherdatasource/location/point">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[Search for weather data sources that serve the specific point.]]></wadl:doc>
        <wadl:request>
          <wadl:param name="findForCountry" style="query">
            <wadl:doc><![CDATA[if true, figures out which country the point is in, and returns all weather data sources that are valid for that country. VERY TIME CONSUMING]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[in decimal degrees (WGS84)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[in decimal degrees (WGS84)]]></wadl:doc>
          </wadl:param>
          <wadl:param name="tolerance" style="query">
            <wadl:doc><![CDATA[Add some tolerance (in meters) to allow for e.g. a point to match
the location of a weather station. The default is 0 meters (no tolerance)]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[A list of all the matching weather data sources]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/weatherparameter/location/point">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:request>
          <wadl:param name="includeCalculatableParams" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="includeFallbackParams" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="latitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="longitude" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
          <wadl:param name="tolerance" style="query">
            <wadl:doc><![CDATA[]]></wadl:doc>
          </wadl:param>
        </wadl:request>
        <wadl:response>
          <wadl:doc><![CDATA[]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>

    <wadl:resource path="rest/testdata/weather/interpolation/temperature">
      <wadl:method name="GET">
        <wadl:doc><![CDATA[]]></wadl:doc>
        <wadl:response>
          <wadl:doc><![CDATA[A weatherdataset with some missing temperatures]]></wadl:doc>
          <wadl:representation mediaType="application/json"/>
        </wadl:response>
      </wadl:method>
    </wadl:resource>
  </wadl:resources>
</wadl:application>
